#
# osc-oracle-generic.spec
#

#
#  Copyright (C) 2008, 2010 Oracle.  All rights reserved.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public
#  License as published by the Free Software Foundation, version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public
#  License along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA
#

#
# Oracle Storage Connect Generic plugin .spec file
#

#
# These defines need to be set to reflect the specific plugin
#
%define     vendor_name     oracle
%define     plugin_module   generic

%define     generic_src_dir generic 
%define     generic_files   __init__.py SCSIPlugin.py NFSPlugin.py

Vendor:     Oracle
Summary:    Oracle Storage Connect Generic Plugins
URL:        http://oss.oracle.com/

License:    GPLv2
BuildArch:  noarch

###########################################################################
#                                                                         #
# The following defines are generic and should not need to be changed     #
#                                                                         #
###########################################################################

%define     dist            .el5
%define     build_dir       %{_builddir}/%{name}-%{version}
%define     plugin_dir      /opt/storage-connect/plugins
%define     vendor_dir      %{plugin_dir}/%{vendor_name}
%define     install_dir     %{vendor_dir}/%{plugin_module}
%define     sharedoc_dir    /usr/share/doc/%{name}

Name:       osc-%{vendor_name}-%{plugin_module}
Version:    1.1.0 
Release: 39%{dist}
Group:      Oracle/StorageConnect
Source0:    %{name}-%{version}.tar.bz2
Patch1:     dummy.patch
Patch2: added-generic-flag.patch
Patch3: version-1.1.0.patch
Patch4: generic_fs_stamp_corruption_fix.patch
Patch5: list_with_file_size.patch
Patch6: bunch_of_bugs.patch
Patch7: sharepath_namefilter.patch
Patch8: auto_mountpoint_create.patch
Patch9: fix-create-mount-point.patch
Patch10: mount-path-create-recursive-create.patch
Patch11: filesys_path-not-in-fs-record.patch
Patch12: discovery_mount_options_fix.patch
Patch13: fs_stamp_on_mount.patch
Patch14: filter-extraneous-filesystems.patch
Patch15: containsFile_fix_and_mor_logging.patch
Patch16: added-api-required-version.patch
Patch17: se_record-path-should-be-list.patch
Patch18: update-to-spec-127.patch
Patch19: added-FS_STATES.patch
Patch20: access_path.patch
Patch21: add_free_sz_to_fs_record.patch
Patch22: patch5688.patch
Patch23: fix-create-syntax.patch
Patch24: fix-FS-STATES-in-create.patch
Patch25: create-should-not-allow-read-only.patch
Patch26: remove_unsupported_apis.patch
Patch27: getCurrentClones.patch
Patch28: fix_iplugin_logger_typo.patch
Patch29: non-sparse-create.patch
Patch30: create_fix.patch
Patch31: list_fix.patch
Patch32: added_Generic_Volume_Group.patch
Patch33: two_volume_groups.patch
Patch34: FC_to_SAN_VG.patch
Patch35: add_vol_groups_to_ssrecord.patch
Patch36: getStatus_return.patch
Patch37: fix-mode.patch
Patch38: parallel_mounts.patch
Patch39: getExports_error_handling.patch
# End Oracle Patches

BuildRoot:  %{_tmppath}/%{name}-%{version}
Requires:   osc-plugin-manager >= 1.2.1

%description
Oracle Storage Connect Generic plugin.

%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0

%build

%install
rm -fr %{buildroot}
install -d -m0755 %{buildroot}/%{install_dir}
install -d -m0755 %{buildroot}/%{sharedoc_dir}
mv %{build_dir}/%{generic_src_dir}/COPYING %{buildroot}/%{sharedoc_dir}/.
rm -fr %{build_dir}/%{sharedoc_dir}
for generic_file in %{generic_files}
do
  mv %{build_dir}/%{generic_src_dir}/${generic_file} %{buildroot}/%{install_dir}/.
done

%clean
rm -fr %{buildroot}

%files
%defattr(0555, root, root, 0555)
%attr(0555, root, root) /*
%doc %{sharedoc_dir}/*

%%preun
if [ $1 -eq 0 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_erase" ]
    then
        $OSC_BIN/announce_erase "%{name}" \
                                "%{version}-%{release}" \
                                "%{install_dir}" \
                                "%{vendor_name}" \
                                "%{plugin_module}"
    fi
    if [ -f %{vendor_dir}/__init__.py ]
    then
        python %{vendor_dir}/__init__.py %{vendor_dir} >/dev/null 2>&1
        if [ "$?" -eq 0 ]
        then
            rm -f %{vendor_dir}/__init__.py
            rm -f %{vendor_dir}/__init__.pyc
            rm -f %{vendor_dir}/__init__.pyo
        fi
    fi
fi
exit 0

%postun
if [ $1 -ge 1 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_upgrade" ]
    then
        $OSC_BIN/announce_upgrade "%{name}" \
                                  "%{version}-%{release}" \
                                  "%{install_dir}" \
                                  "%{vendor_name}" \
                                  "%{plugin_module}"
     fi
elif [ $1 -eq 0 ]
then
    rmdir --ignore-fail-on-non-empty %{install_dir}
    rmdir --ignore-fail-on-non-empty %{vendor_dir}
fi
exit 0

%post
OSC_BIN=/opt/storage-connect/bin
if [ -x "$OSC_BIN/announce_install" ]
then
    $OSC_BIN/announce_install "%{name}" \
                              "%{version}-%{release}" \
                              "%{install_dir}" \
                              "%{vendor_name}" \
                              "%{plugin_module}"
fi
if [ ! -f %{vendor_dir}/__init__.py ]
then
    cat >%{vendor_dir}/__init__.py <<__EOF__
#!/usr/bin/env python
"""
@copyright: Copyright (C) 2008, 2010 Oracle.  All rights reserved.

@license:   This program is free software; you can redistribute it and/or
            modify it under the terms of the GNU General Public
            License as published by the Free Software Foundation, version 2.

            This program is distributed in the hope that it will be useful,
            but WITHOUT ANY WARRANTY; without even the implied warranty of
            MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
            General Public License for more details.

            You should have received a copy of the GNU General Public
            License along with this program; if not, write to the Free Software
            Foundation, Inc., 59 Temple Place - Suite 330, Boston,
            MA 021110-1307, USA

@summary:   This is just to enable the import of the plugins.
"""

#
# This is a major hack to get around RPM's limitation of not being able
# to specify the same file for multiple RPM installs
#
# Exit codes:
#   0 : No more dependencies
#   1 : ERROR condition
#   2 : Still have dependencies
#
if __name__ == '__main__':
    import sys
    import os
    if len(sys.argv) <= 1:
        print "ERROR: No vendor dir given!"
        sys.exit(1)

    try:
       vendor_dirs = os.listdir(sys.argv[1])
       ref_count = 0
       for vendor_dir in vendor_dirs:
           vendor_path = os.path.join(sys.argv[1], vendor_dir)
           if os.path.isdir(vendor_path):
               ref_count += 1

    except Exception, e:
        print "ERROR:", e
        sys.exit(1)

    if ref_count > 1:
        sys.exit(2)

    sys.exit(0)

__EOF__
fi
exit 0

%changelog
* Fri Jul 22 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-39 
- Added error handling to _getExports [bug 12769921] 

* Wed Jul 20 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-38 
- Added mkdtemp to protect parallel mounts. 

* Wed Jul 06 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.1.0-37 
- fix the file/dir creation mode for NFSPlugin
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Cathy Avery <cathy.avery@oracle.com> [bug 12719289] 

* Fri Jul 01 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-36 
- getStatus now always returns a value or exception [bug 11825213] 

* Thu May 19 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-35 
- Added ss_record vol_groups 

* Mon Apr 18 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-34 
- Changed volume group from FC to SAN 

* Sun Apr 17 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-33 
- Changed volume group to "Generic_Iscsi_Volume_Group" and "Generic_FibreChannel_Volume_Group" 

* Thu Apr 14 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-32 
- Added 'Generic_Volume_Group' to se_record[vol_group_name] 

* Mon Mar 21 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-31 
- Fixed list method to return only those iscsi /dev/mpath/ devices that belong to the
  specified ss_name. The get mp page 83 is only temporary. [bug 11847174] 

* Tue Mar 15 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-30 
- Cosmetice name change to SCSIPlugin. Fixed create problem. [bug 11873198] 

* Fri Mar 11 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-29 
- Fixed non sparse create. [bug 11851616] 

* Wed Mar 02 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.1.0-28 
- Fix typo in IPlugin.logger references [bug 11825744] 

* Fri Feb 25 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-27 
- Added getCurrentClones to return empty list [bug 11793771] 

* Mon Feb 21 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-26 
- removed unsupported call stubs. 

* Fri Feb 04 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-25 
- Cannot create a file on a read only mounted file system 

* Fri Feb 04 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-24 
- Fixed FS_TYPES in create call... 

* Wed Feb 02 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-23 
- Fix create() syntax to match 1.2.7 spec 

* Thu Jan 27 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-22 
- Fixed sharepath to allow for None... 

* Tue Jan 25 2011 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-21 
- Added new fs_record field free_sz 

* Wed Jan 05 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-20 
- Changed filesys_path to access_path for networked file systems... 

* Tue Jan 04 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-19 
- Added the FS_STATES 

* Tue Jan 04 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-18 
- Updated to match spec 1.2.7 

* Tue Jan 04 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-17 
- Changed list and updateSERecords to return a list for the device path
  bug:10632709 

* Fri Dec 17 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-16 
- Plugins must set their min compat level, as of 1.27 plugin manager checks this 

* Wed Dec 15 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-15
- Possible bug fix for 10398326 with extended general and debug logging.

* Mon Nov 29 2010 Kurt Hackel <kurt.hackel@oracle.com> - 1.1.0-14 
- Reinstate filtering out extraneous files systems when fs_record is indicated in listMountPoints. [bug 10334559] 

* Tue Nov 23 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-13 
- Added uuid stamps to all subdir mounts. This avoids having to mount the nfs root to get the uuidand cuts down on nfs mount activity. This a patch is a partial fix for bug 10278397. [bug 102778397] 

* Mon Nov 15 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-12 
- Trial fix for bug 10278397. 

* Wed Nov 10 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-11 
- Need to make sure in listMountPoints that the mount point to check is not a read-only non stamped mount point
  orabug:10268910 

* Fri Nov 05 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-10 
- Changed mount() call to make the mount path recursively 

* Mon Nov 01 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-9 
- Fix problem where mount point does not exist and flag is supplied to create it on mount 

* Mon Oct 25 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-8 
- Added create mount point to mount feature. 

* Mon Oct 18 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-7 
- Added share_path feature for mounts. Added filter names for list. 

* Thu Sep 09 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-6 
- Assorted bug fixes from manager testing. 

* Fri Sep 03 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-5 
- Added file size info to the file records returned from list. 

* Thu Sep 02 2010 Cathy Avery <cathy.avery@oracle.com> - 1.1.0-4 
- Fixed .generic_fs_stamp going to null. Fixed emtpy .generic_fs_stamp not being updated with a valid uuid. 

* Fri Aug 27 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-3 
- Bumped version to 1.1.0 

* Fri Aug 27 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.1.0-2 
- Added the generic flag 

* Thu Aug 26 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-10 
- Renamed FSPlugin to NFS plugin. 

* Wed Aug 25 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-9 
- Removed a NFSFilesystem ref I missed 

* Mon Aug 23 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-8 
- storage_type should check for FileSys.. 

* Mon Aug 23 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-7 
- Changed StringReader to StringIO 

* Mon Aug 23 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-6 
- Sync up with OSC plugin 

* Thu Aug 19 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-5 
- Changed fillSSInfo to not set fields to None, Changed the AccessGroup return a valid dict (for now) This call should never be called since the flag is set to indicate that Access control is not supported 

* Wed Aug 18 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 1.0.0-4 
- Updated NFSFileSystem to NetworkFileSystem 

* Wed Jul 21 2010 Cathy Avery <cathy.avery@oracle.com> - 1.0.0-3 
- Added generic file system plugin. Changed scsi plugin ability report. 

* Thu Jul 01 2010 Cathy Avery <cathy.avery@oracle.com> - 1.0.0-2 
- Fixed dd block size, fixed error message bug in clone 

* Fri May 28 2010 Joel Becker <joel.becker@oracle.com> 1.0.0-1
- Initial generic version of this specfile

